#include <iostream>
using namespace std;
int main()
{
    int n,m,q;
    cin>>n>>m;
    long long a[n+1][m+1];
    long long suma=0;
    for(int i=1;i<n+1;i++)
        for(int j=1;j<m+1;j++)
        cin>>a[i][j];
    cin>>q;
    int b[q][2];
    for(int i=0;i<q;i++)
    {
        for(int j=0;j<2;j++)
        {
            cin>>b[i][j];
        }
    }
    for(int l=0;l<q;l++)
    {
      suma=0;
      int i=1;
      int j=1;
      while(a[i][j]!=a[n][m])
      {
         suma+=a[i][j];
          if(i+1 == b[l][1])
          {
              j++;
          }
          if(j+1 ==b[l][1])
          {
              i++;
          }
          else if(a[i][j+1]>a[i+1][j]){i++;}
          else if(a[i+1][j]>a[i][j+1]){j++;}
      }
      cout<<suma<<endl;
    }
    return 0;
}